# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [Unreleased]

---

## [0.0.2] - 2018-11-18

Deployed on:
* https://books.vvvvvvaria.org/

### Added
* Use [Pipenv](https://pipenv.readthedocs.io/en/latest/) for dependency management.
* A bootstrap [scripts](scripts) folder for running development server and shell.
* Add a dummy test suite which uses [pytest](https://docs.pytest.org/en/latest/).
* An [Ansible](https://docs.ansible.com/) deployment method in the [ansible](ansible) folder.
* Add documentation in [README.md](README.md) and [ansible/README.md](ansible/README.md).

### Changed
* Move all application source code into the [xppl](xppl) folder.
* Bootstrap the application via [xppl/app.py](xppl/app.py).
* Added [Makefile](Makefile) targets for installing [RQLite](https://github.com/rqlite/rqlite).
* Run [isort](https://isort.readthedocs.io/en/latest/) and [pylava](https://github.com/pylava/pylava)
  code audit tools over the source.
* Use a new [Hypothesis](https://web.hypothes.is/) API key.

### Fixed
* A bug in the scrolling homepage message where missing information resulted in a NoneType error.

### Removed
* The `import_csv.py` since we'll probably use [Alembic](https://alembic.sqlalchemy.org/en/latest/) migrations instead.
* The `rebuild.py` since it appears the application doesn't use [Whoosh](https://whoosh.readthedocs.io/en/latest/intro.html) any more.
* The basic `init.py` which originally built the database. Done in [xppl/app.py](xppl/app.py) now.

## [0.0.1] - 2018-10-29

* Initial release. No change log entries.
